unit Color;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Mandelbrot, ComCtrls;

type
  TColorForm = class(TForm)
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    Button3: TButton;
    Button4: TButton;
    Panel3: TPanel;
    Panel4: TPanel;
    GroupBox3: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    UpDown3: TUpDown;
    Label4: TLabel;
    Label5: TLabel;
    GroupBox4: TGroupBox;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Button5: TButton;
    GroupBox2: TGroupBox;
    ComboBox1: TComboBox;
    GroupBox5: TGroupBox;
    Edit1: TEdit;
    UpDown1: TUpDown;
    GroupBox6: TGroupBox;
    Label1: TLabel;
    Edit8: TEdit;
    UpDown2: TUpDown;
    GroupBox7: TGroupBox;
    Edit9: TEdit;
    UpDown4: TUpDown;
    GroupBox8: TGroupBox;
    Label14: TLabel;
    Edit10: TEdit;
    UpDown5: TUpDown;
    Label15: TLabel;
    Edit11: TEdit;
    UpDown6: TUpDown;
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Edit2KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure RadioButton6Click(Sender: TObject);
    procedure RadioButton7Click(Sender: TObject);
    procedure RadioButton8Click(Sender: TObject);
    procedure Edit4KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit5KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit6KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit7KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button5Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure UpDown5Click(Sender: TObject; Button: TUDBtnType);
    procedure UpDown5MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure UpDown6Click(Sender: TObject; Button: TUDBtnType);
    procedure UpDown6MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private 錾 }
  public
    { Public 錾 }
    g, la, ra, lR, rR: Extended;
    Btn: TUDBtnType;
    procedure DispValues;
    procedure CheckValues;
  end;

var
  ColorForm: TColorForm;

implementation

uses Frame;

{$R *.DFM}

procedure TColorForm.DispValues;
begin
  Edit2.Text := FloatToStr(g);
  Edit3.Text := IntToStr(UpDown3.Position);
  Edit4.Text := FloatToStr(la);
  Edit5.Text := FloatToStr(lR);
  Edit6.Text := FloatToStr(ra);
  Edit7.Text := FloatToStr(rR);
end;

procedure TColorForm.CheckValues;
var
  x: Extended;
begin
  try
    x := StrToFloat(Edit2.Text);
  except
    x := g;
  end;
  if x < 0.1 then x := 0.1
   else if x > 10 then x := 10;
  g := x;
  Edit2.Text := FloatToStr(g);

  try
    x := StrToFloat(Edit4.Text);
  except
    x := la;
  end;
  if x < 0.001 then x := 0.001
   else if x > 3.14 then x := 3.14;
  la := x;
  Edit4.Text := FloatToStr(la);

  try
    x := StrToFloat(Edit5.Text);
  except
    x := lR;
  end;
  if x < 0.01 then x := 0.01
   else if x > 1.2 then x := 1.2;
  lR := x;
  Edit5.Text := FloatToStr(lR);

  try
    x := StrToFloat(Edit6.Text);
  except
    x := ra;
  end;
  if x < 0.001 then x := 0.001
   else if x > 3.14 then x := 3.14;
  ra := x;
  Edit6.Text := FloatToStr(ra);

  try
    x := StrToFloat(Edit7.Text);
  except
    x := rR;
  end;
  if x < 0.01 then x := 0.01
   else if x > 1.2 then x := 1.2;
  rR := x;
  Edit7.Text := FloatToStr(rR);
end;

procedure TColorForm.FormShow(Sender: TObject);
begin
  ComboBox1.ItemIndex := FrameForm.ComboBox1.ItemIndex;

  Left := FrameForm.Parameter1['CLeft'];
  Top := FrameForm.Parameter1['CTop'];
  ClientWidth := 408;
  ClientHeight := 373;

  if ComboBox1.ItemIndex < 2 then
  begin
    Panel3.Color := Byte2Col(FrameForm.Mandelbrot1.ColorOffset);
    Panel4.Color := Byte2Col(FrameForm.Mandelbrot1.BackColor);
  end
  else
  begin
    Panel3.Color := FrameForm.pC;
    Panel4.Color := FrameForm.bC;
  end;
  Button3.Caption := '\F( ' + IntToStr(Col2Byte(Panel3.Color)) + ' )';
  Button4.Caption := 'wiF( ' + IntToStr(Col2Byte(Panel4.Color)) + ' )';

  if ComboBox1.ItemIndex = 3 then // Cantor set
  begin
    UpDown1.Max := 20;
    UpDown1.Position := FrameForm.cW;
  end
  else
  begin
    UpDown1.Max := 5;
    UpDown1.Position := FrameForm.pW;
  end;

  UpDown2.Position := FrameForm.cG;
  UpDown4.Position := FrameForm.rC;
  UpDown5.Position := FrameForm.kN;
  UpDown6.Position := FrameForm.cN;

  DispValues;
end;

procedure TColorForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  FrameForm.Parameter1['CLeft'] := Left;
  FrameForm.Parameter1['CTop'] := Top;
end;

procedure TColorForm.Button1Click(Sender: TObject);
begin
  FrameForm.Fractal := ComboBox1.ItemIndex;
  FrameForm.ComboBox1.ItemIndex := ComboBox1.ItemIndex;

  if ComboBox1.ItemIndex < 2 then
  begin
    FrameForm.Mandelbrot1.ColorOffset := Col2Byte(Panel3.Color);
    FrameForm.Mandelbrot1.BackColor := Col2Byte(Panel4.Color);
  end
  else
  begin
    FrameForm.pC := Panel3.Color;
    FrameForm.bC := Panel4.Color;
  end;

  if ComboBox1.ItemIndex = 3 then // Cantor set
    FrameForm.cW := UpDown1.Position
  else
    FrameForm.pW := UpDown1.Position;

  FrameForm.cG := UpDown2.Position;
  FrameForm.rC := UpDown4.Position;
  FrameForm.kN := UpDown5.Position;
  FrameForm.cN := UpDown6.Position;

  CheckValues;
end;

procedure TColorForm.Button3Click(Sender: TObject);
begin
  FrameForm.ColorDialog1.Color := Panel3.Color;
  if FrameForm.ColorDialog1.Execute then
  begin
    Panel3.Color := FrameForm.ColorDialog1.Color;
    Button3.Caption := '\F( ' + IntToStr(Col2Byte(Panel3.Color)) + ' )';
  end;
end;

procedure TColorForm.Button4Click(Sender: TObject);
begin
  FrameForm.ColorDialog1.Color := Panel4.Color;
  if FrameForm.ColorDialog1.Execute then
  begin
    Panel4.Color := FrameForm.ColorDialog1.Color;
    Button4.Caption := 'wiF( ' + IntToStr(Col2Byte(Panel4.Color)) + ' )';
  end;
end;

procedure TColorForm.Edit2KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    CheckValues;
end;

procedure TColorForm.FormCreate(Sender: TObject);
begin
  g := 1.12;
  la := 0.3;
  ra := 0.3;
  lR := 0.7;
  rR := 0.7;
end;

procedure TColorForm.RadioButton1Click(Sender: TObject);
begin
  g := 1.12;
  Edit2.Text := '1.12';
end;

procedure TColorForm.RadioButton2Click(Sender: TObject);
begin
  g := 0.784;
  Edit2.Text := '0.784';
end;

procedure TColorForm.RadioButton3Click(Sender: TObject);
begin
  la := 0.3; Edit4.Text := '0.3';
  lR := 0.7; Edit5.Text := '0.7';
  ra := 0.3; Edit6.Text := '0.3';
  rR := 0.7; Edit7.Text := '0.7';
end;

procedure TColorForm.RadioButton4Click(Sender: TObject);
begin
  la := 0.1; Edit4.Text := '0.1';
  lR := 0.7; Edit5.Text := '0.7';
  ra := 0.1; Edit6.Text := '0.1';
  rR := 0.7; Edit7.Text := '0.7';
end;

procedure TColorForm.RadioButton5Click(Sender: TObject);
begin
  la := 0.5; Edit4.Text := '0.5';
  lR := 0.8; Edit5.Text := '0.8';
  ra := 0.5; Edit6.Text := '0.5';
  rR := 0.8; Edit7.Text := '0.8';
end;

procedure TColorForm.RadioButton6Click(Sender: TObject);
begin
  la := 1; Edit4.Text := '1';
  lR := 0.7; Edit5.Text := '0.7';
  ra := 1; Edit6.Text := '1';
  rR := 0.7; Edit7.Text := '0.7';
end;

procedure TColorForm.RadioButton7Click(Sender: TObject);
begin
  la := 2; Edit4.Text := '2';
  lR := 0.7; Edit5.Text := '0.7';
  ra := 2; Edit6.Text := '2';
  rR := 0.7; Edit7.Text := '0.7';
end;

procedure TColorForm.RadioButton8Click(Sender: TObject);
begin
  la := 0.4; Edit4.Text := '0.4';
  lR := 0.85; Edit5.Text := '0.85';
  ra := 0.1; Edit6.Text := '0.1';
  rR := 0.65; Edit7.Text := '0.65';
end;

procedure TColorForm.Edit4KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    CheckValues;
end;

procedure TColorForm.Edit5KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    CheckValues;
end;

procedure TColorForm.Edit6KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    CheckValues;
end;

procedure TColorForm.Edit7KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    CheckValues;
end;

procedure TColorForm.Button5Click(Sender: TObject);
begin
  Left := 192;
  Top := 114;

  ComboBox1Change(Sender);

  UpDown3.Position := 20;
  RadioButton1.Checked := True;
  RadioButton3.Checked := True;

  g := 1.12;
  la := 0.3;
  ra := 0.3;
  lR := 0.7;
  rR := 0.7;

  DispValues;
end;

procedure TColorForm.ComboBox1Change(Sender: TObject);
begin
  case ComboBox1.ItemIndex of
    0, 1: Panel3.Color := Byte2Col(FrameForm.Mandelbrot1.ColorOffset);
    2..7: Panel3.Color := FrameForm.sC; // Standard Color
    8, 11: Panel3.Color := clGreen;
    9: Panel3.Color := clRed;
    10: Panel3.Color := clFuchsia;
  end;
  Button3.Caption := '\F( ' + IntToStr(Col2Byte(Panel3.Color)) + ' )';

  if ComboBox1.ItemIndex < 2 then
    Panel4.Color := Byte2Col(FrameForm.Mandelbrot1.BackColor)
  else
    Panel4.Color := FrameForm.bC;
  Button4.Caption := 'wiF( ' + IntToStr(Col2Byte(Panel4.Color)) + ' )';

  UpDown1.Max := 5;
  UpDown1.Position := 2;
  UpDown2.Position := 10;
  UpDown4.Position := 4;
  UpDown5.Position := 3;
  UpDown6.Position := 4;
  case ComboBox1.ItemIndex of
    3: begin // Cantor set
         UpDown1.Max := 20;
         UpDown1.Position := 10;
         UpDown4.Position := 5;
       end;
    6: UpDown4.Position := 5; // Hilbert curve
    7: UpDown4.Position := 3; // Peano curve
    9: UpDown4.Position := 14; // Dragon curve
    10: UpDown4.Position := 11; // Levy C curve
    11: begin // Fractal tree
          UpDown1.Position := 1;
          UpDown4.Position := 12;
        end;
  end;
end;

procedure TColorForm.UpDown5Click(Sender: TObject; Button: TUDBtnType);
begin
  Btn := Button;
end;

procedure TColorForm.UpDown5MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Btn = btNext then
  begin
    if UpDown5.Position in [1, 2] then
      UpDown5.Position := 3;
  end
  else if Btn = btPrev then
  begin
    if UpDown5.Position in [1, 2] then
      UpDown5.Position := 0;
  end;
end;

procedure TColorForm.UpDown6Click(Sender: TObject; Button: TUDBtnType);
begin
  Btn := Button;
end;

procedure TColorForm.UpDown6MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Btn = btNext then
  begin
    if UpDown6.Position in [1, 2] then
      UpDown6.Position := 3;
  end
  else if Btn = btPrev then
  begin
    if UpDown6.Position in [1, 2] then
      UpDown6.Position := 0;
  end;
end;

end.
